#include "selection.h"


Selection::Selection()
{
}

Selection::~Selection()
{
}

void Selection::setMapCenter(MapCenterObj *mco)
{
	mapCenter=mco;
}

void Selection::copy(const Selection &other)
{
	mapCenter=other.mapCenter;
	selectList=other.selectList;
	lastSelectList=other.lastSelectList;
}

void Selection::clear()
{
	selectList.clear();
	lastSelectList.clear();
}

bool Selection::select(LinkableMapObj *lmo)	// TODO no multiselections yet
{
	clear();
	selectList.append (lmo);
	return false;
}

bool Selection::select (const QString &s)	// TODO no multiselections yet
{
	LinkableMapObj *lmo=mapCenter->findObjBySelect(s);

	// Finally select the found object
	if (lmo)
	{
		clear();
		select (lmo);
		return true;
	} 
	return false;

}

bool Selection::reselect ()	// TODO no multiselections yet
{
	if (!lastSelectList.isEmpty())
	{
		select (lastSelectList.first());
		return true;
	}
	return false;

}

void Selection::unselect()
{
	lastSelectList=selectList;
	selectList.clear();
}

bool Selection::isEmpty()
{
	return selectList.isEmpty();
}

uint Selection::count()
{
	return selectList.count();
}

SelectionType Selection::type() // TODO no multiselections yet
{
	if (!selectList.isEmpty())
	{
		LinkableMapObj *sel=selectList.first();
		if (typeid (*sel)==typeid (BranchObj)) return Branch;
		if (typeid (*sel)==typeid (MapCenterObj)) return MapCenter;
		if (typeid (*sel)==typeid (FloatImageObj)) return FloatImage;
	}
	return Undefined;
}

QString Selection::getSelectString()// TODO no multiselections yet
{
	if (selectList.count()==1)
		return selectList.first()->getSelectString();
	else
		return"";
}


